/* xpin.h
**
** XpinDoc
** an XML parse instance document processing utility
**
** Copyright (C) 2002, 2003, Wayne Marshall
** All rights reserved, worldwide.
**
** wcm, 2002.05.20 - 2003.09.30
** ===
*/
#ifndef  XPIN_H
#define  XPIN_H  1

/* XPINDOC OBJECT INTERNALS: */
#include  "xpin_parser.h"


/* namespace separator: */
#define  XPIN_NSSEP  '\001'

/*
** expose xpin object internals for xpin_handlers
*/
struct xpin {
    Xpin_Parser          parser;
    int                  ns_parser;
    char                 ns_sep;
    int                  using_qname;
    int                  datamode;
    int                  ignore;
    /* user halt: */
    int                  is_halted;
    /* internal error halt: */
    int                  is_croaked;
    struct xpin_event   *event;
    struct xpin_node    *node;
    struct xpin_pi      *pi;
    struct xpin_writer  *writer;
    struct xpin_error   *error;
    /* user-installed payload: */
    void                *mydata;
    /* input filter: */
    void       (*filter)(struct xpindoc *X, const char *data, int len);
    /* handler suite for this document: */
    struct xpin_handler_suite  *suite;
    /* methods to access parser: */
    int        (*line)(struct xpin *);
    int        (*column)(struct xpin *);
    int        (*size)(struct xpin *);
    long int   (*offset)(struct xpin *);
};


/*
  note:  xpin creator/destructor local to xpin.c module
*/


#endif  /* XPIN_H */
