/* xpin_macros.h
**
** XpinDoc
** an XML parse instance document processing utility
**
** Copyright (C) 2002, 2003, Wayne Marshall
** All rights reserved, worldwide.
**
** wcm, 2002.05.20 - 2003.09.30
** ===
*/
#ifndef  XPIN_MACROS_H
#define  XPIN_MACROS_H  1

/*
** Optional "syntactic sugar" macros for XpinDoc applications.
*/

/* return current processing instruction (Xpin_PI) from xpindoc object: */
#define PI(xpin) \
  (xpin)->pi(xpin)

#define PI_TARGET(pi) \
  (pi)->target(pi)

#define PI_DATA(pi) \
  (pi)->data(pi)

/* return current node (Xpin_Node) from xpindoc object: */
#define NODE(xpin) \
  (xpin)->node(xpin)

/* return content of node: */
#define CONTENT(node) \
  (node)->content(node)

/* trim content of current node: */
#define TRIM(node) \
  (node)->content_trim(node)

/* true if current event is start element: */
#define IF_START(xpin) \
  if((xpin)->event_type((xpin)) == XPIN_START_ELEMENT)

/* true if current event is end element: */
#define IF_END(xpin) \
  if((xpin)->event_type((xpin)) == XPIN_END_ELEMENT)

/* put_string: */
#define PUT_STRING(xpin,string) \
  (xpin)->put_string((xpin), (string))

/* set_handler: */
#define SET_HANDLER(xpin,pattern,callback) \
  (xpin)->set_handler((xpin), (pattern), (callback))

#endif  /* XPIN_MACROS_H */
